## purify 5.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(Purify C CXX)

# Location of extra cmake includes for the project
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_files)
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/build)

option(tests          "Enable testing"                                  on)
option(examples       "Compile examples"                                off)
option(benchmarks     "Enable benchmarking"                             off)
option(openmp         "Enable OpenMP"                                   on)
option(dompi          "Enable MPI"                                      on)
option(doaf           "Enable ArrayFire"                                off)
option(docimg         "Enable CImg"                                     off)
option(docasa         "Enable CASA"                                     off)
option(docs           "Build documentation"                             off)
option(coverage       "Build coverage"                                  off)
option(onnxrt         "Build with ONNXruntime interface"                off)
option(hdf5           "Build with HDF5 interface"                       off)

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build Type" FORCE)
endif()
message(STATUS "Building purify in ${CMAKE_BUILD_TYPE} mode")

# Set version and build id of this package
include(version)
set(Sopt_GIT_TAG "development" CACHE STRING "Branch/tag when downloading sopt")

## we are doing c++11
#include(AddCPP11Flags)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# sets up rpath so libraries can be found
include(rpath)

# include exernal dependencies
include(dependencies)

set(PURIFY_TEST_LOG_LEVEL critical CACHE STRING "Level when logging tests")
set_property(CACHE PURIFY_TEST_LOG_LEVEL
             PROPERTY STRINGS off critical error warn info debug trace)

# If PURIFY_OPENMP is set to False in dependencies, link libpthread here so that the linker finds it
# Following advice from https://stackoverflow.com/questions/1620918/cmake-and-libpthread
if(NOT PURIFY_OPENMP)
  set(CMAKE_THREAD_LIBS_INIT "-lpthread")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")

if(tests AND coverage)
  # Enable code coverage.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
  # Build with debugging information to make the output meaningful.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
  # Disable optimizations to get the most accurate results.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
endif()

add_subdirectory(cpp)

# Exports Purify so other packages can access it
include(export_purify)

=== cpp/CMakeLists.txt ===
# adds include dirs which are located within the build directory
# That is, whathever package is downloaded automatically by the build system
# This complication arises because cmake won't install targets with headers that point to the build
# dir.
# Users will have to install packages globally for all the right headers to be found
function(add_include_dir)
  unset(privates)
  foreach(dir ${ARGN})
    file(RELATIVE_PATH rel "${PROJECT_BINARY_DIR}" "${dir}" )
    if(NOT "${rel}" MATCHES "^\\.\\./")
      list(APPEND privates "${dir}")
    endif()
  endforeach()
  if(privates)
    include_directories(SYSTEM ${privates})
  endif()
endfunction()

add_include_dir(
  ${EIGEN3_INCLUDE_DIR}
  ${Boost_INCLUDE_DIR}
  ${cfitsio_INCLUDE_DIR}
  ${yaml-cpp_INCLUDE_DIR}
  ${Cubature_INCLUDE_DIR}
  ${CImg_INCLUDE_DIR}
  ${HDF5_INCLUDE_DIR}
  ${HighFive_INCLUDE_DIR}
)


link_directories(${FFTW3_LIBRARY_DIRS} ${YAML_CPP_LIBRARY_DIR} ${Cubature_LIBRARY_DIR})
add_subdirectory(purify)
if(tests OR examples OR benchmarks)
  configure_file(tests/directories.in.h "${PROJECT_BINARY_DIR}/include/purify/directories.h")
endif()
if(examples)
  add_subdirectory(example)
endif()
if(tests)
  configure_file(tests/data.in.h "${PROJECT_BINARY_DIR}/include/purify/test_data.h")
  add_subdirectory(tests)
endif()
if(benchmarks)
  add_subdirectory(benchmarks)
endif()
if (docs)
  add_subdirectory(docs)
endif()

add_subdirectory(uncertainty_quantification)

add_executable(purify main.cc)
set_target_properties(purify PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
target_link_libraries(purify libpurify ${sopt_LIBRARIES})

install(TARGETS purify
  EXPORT PurifyTargets
  DESTINATION share/cmake/Purify
  RUNTIME DESTINATION bin
)

=== cpp/benchmarks/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include" "${benchmark_DIR}/include")

add_executable(measurement_operator utilities.cc measurement_operator.cc)
target_link_libraries(measurement_operator benchmark::benchmark libpurify)

add_executable(algorithms utilities.cc algorithms.cc)
target_link_libraries(algorithms benchmark::benchmark libpurify)

add_executable(wavelet_operator utilities.cc wavelet_operator.cc)
target_link_libraries(wavelet_operator benchmark::benchmark libpurify)

add_executable(fft utilities.cc fft.cc)
target_link_libraries(fft benchmark::benchmark libpurify)

add_executable(degridding utilities.cc degridding.cc)
target_link_libraries(degridding benchmark::benchmark libpurify)

# Skip ArrayFire benchmarks for now, add back later if needed
# if(doaf)
#   add_benchmark(measurement_operator_af utilities.cc LIBRARIES libpurify)
#   add_benchmark(measurement_operator_cpu measurement_operator_af.cc utilities.cc LIBRARIES libpurify)
#   target_compile_definitions(benchmark_measurement_operator_cpu PRIVATE PURIFY_CPU)
# endif()

if(dompi)
  add_executable(mpi_benchmark_MO main.cc utilities.cc measurement_operator_mpi.cc)
  target_link_libraries(mpi_benchmark_MO ${MPI_LIBRARIES} benchmark::benchmark libpurify)

  add_executable(mpi_benchmark_MO_wproj main.cc utilities.cc measurement_operator_wproj.cc)
  target_link_libraries(mpi_benchmark_MO_wproj ${MPI_LIBRARIES} benchmark::benchmark libpurify)

  add_executable(mpi_benchmark_algorithms main.cc utilities.cc algorithms_mpi.cc)
  target_link_libraries(mpi_benchmark_algorithms ${MPI_LIBRARIES} benchmark::benchmark libpurify)

  add_executable(mpi_benchmark_WLO main.cc utilities.cc wavelet_operator_mpi.cc)
  target_link_libraries(mpi_benchmark_WLO ${MPI_LIBRARIES} benchmark::benchmark libpurify)

  if(hdf5)
    add_executable(mpi_benchmark_stochastic main.cc utilities.cc stochastic_algorithm.cc)
    target_link_libraries(mpi_benchmark_stochastic ${MPI_LIBRARIES} benchmark::benchmark libpurify)
  endif()

endif()

=== cpp/docs/CMakeLists.txt ===
# Set some Doxygen flags
set(PURIFY_DOXY_PROJECT_NAME "PURIFY")
set(PURIFY_DOXY_PROJECT_BRIEF "Next-generation radio interferometric imaging")
set(PURIFY_DOXY_INPUT "${PROJECT_SOURCE_DIR}/cpp")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
)

file(COPY
  ${CMAKE_CURRENT_SOURCE_DIR}/DoxygenLayout.xml
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
)


if (web)
  file(DOWNLOAD http://astro-informatics.github.io/sopt/sopt.tag ${CMAKE_CURRENT_BINARY_DIR}/sopt/sopt.tag)
endif()

add_custom_target(doc ALL
  COMMAND doxygen
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})


if (web)
  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_custom_target(docweb
      COMMAND sed -i '' -e 's@namespacesopt@http://astro-informatics.github.io/purify/&@g' -e 's@<filename>@&http://astro-informatics.github.io/purify/@g' ${CMAKE_CURRENT_BINARY_DIR}/html/purify.tag
      DEPENDS doc)
  else()
    add_custom_target(docweb
      COMMAND sed -i -e 's@namespacepurify@http://astro-informatics.github.io/purify/&@g' -e 's@<filename>@&http://astro-informatics.github.io/purify/@g' ${CMAKE_CURRENT_BINARY_DIR}/html/purify.tag
      DEPENDS doc)
  endif()
endif()

=== cpp/example/CMakeLists.txt ===
include(AddExample)

include_directories(SYSTEM ${Sopt_INCLUDE_DIRS})
include_directories("${PROJECT_SOURCE_DIR}/cpp")

add_example(gridding LIBRARIES libpurify NOTEST)
add_example(image_wproj_chirp LIBRARIES libpurify NOTEST)
add_example(compare_wprojection LIBRARIES libpurify NOTEST)
add_example(generate_vis_data LIBRARIES libpurify NOTEST)

add_example(plot_wkernel LIBRARIES libpurify NOTEST)
add_example(wavelet_decomposition LIBRARIES libpurify NOTEST)
add_example(histogram_equalisation LIBRARIES libpurify NOTEST)

add_example(show_image LIBRARIES libpurify NOTEST)
add_example(sdmm_m31_simulation LIBRARIES libpurify NOTEST)

add_example(padmm_simulation LIBRARIES libpurify NOTEST)
add_example(padmm_reweighted_simulation LIBRARIES libpurify NOTEST)
add_example(sara_padmm_random_coverage LIBRARIES libpurify NOTEST)



add_example(padmm_real_data LIBRARIES libpurify NOTEST )

add_example(padmm_random_coverage LIBRARIES libpurify NOTEST )
if(PURIFY_ARRAYFIRE)
  add_example(padmm_random_coverage_gpu padmm_random_coverage.cc LIBRARIES libpurify NOTEST )
  target_compile_definitions(example_padmm_random_coverage_gpu PRIVATE PURIFY_GPU)
endif()
if(PURIFY_MPI)
  add_example(global_epsilon_replicated_grids_mpi padmm_mpi_random_coverage.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_global_epsilon_replicated_grids_mpi
    PRIVATE PURIFY_PADMM_ALGORITHM=2)
  add_example(local_epsilon_replicated_grids_mpi padmm_mpi_random_coverage.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_local_epsilon_replicated_grids_mpi
    PRIVATE PURIFY_PADMM_ALGORITHM=3)
  add_example(local_epsilon_distributed_grids_mpi padmm_mpi_random_coverage.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_local_epsilon_distributed_grids_mpi
    PRIVATE PURIFY_PADMM_ALGORITHM=1)
  add_example(global_epsilon_replicated_grids_real_data_mpi padmm_mpi_real_data.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_global_epsilon_replicated_grids_real_data_mpi
    PRIVATE PURIFY_PADMM_ALGORITHM=2)
  add_example(local_epsilon_replicated_grids_real_data_mpi padmm_mpi_real_data.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_local_epsilon_replicated_grids_real_data_mpi
    PRIVATE PURIFY_PADMM_ALGORITHM=3)
  add_example(local_epsilon_distributed_grids_real_data_mpi padmm_mpi_real_data.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_local_epsilon_distributed_grids_real_data_mpi
    PRIVATE PURIFY_PADMM_ALGORITHM=1)
  add_example(time_w_algos LIBRARIES libpurify NOTEST)
  add_example(mem_w_algos LIBRARIES libpurify NOTEST)
endif()
if(PURIFY_MPI AND PURIFY_ARRAYFIRE)
  add_example(global_epsilon_replicated_grids_gpu padmm_mpi_random_coverage.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_global_epsilon_replicated_grids_gpu
    PRIVATE PURIFY_PADMM_ALGORITHM=2 PURIFY_GPU)
  add_example(local_epsilon_replicated_grids_gpu padmm_mpi_random_coverage.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_local_epsilon_replicated_grids_gpu
    PRIVATE PURIFY_PADMM_ALGORITHM=3 PURIFY_GPU)
  add_example(local_epsilon_distributed_grids_gpu padmm_mpi_random_coverage.cc NOTEST
    LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
  target_compile_definitions(example_local_epsilon_distributed_grids_gpu
    PRIVATE PURIFY_PADMM_ALGORITHM=1 PURIFY_GPU)
  if(TARGET casacore::ms)
    add_example(global_epsilon_replicated_grids_real_data_gpu padmm_mpi_real_data.cc NOTEST
      LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
    target_compile_definitions(example_global_epsilon_replicated_grids_real_data_gpu
      PRIVATE PURIFY_PADMM_ALGORITHM=2 PURIFY_GPU)
    add_example(local_epsilon_replicated_grids_real_data_gpu padmm_mpi_real_data.cc NOTEST
      LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
    target_compile_definitions(example_local_epsilon_replicated_grids_real_data_gpu
      PRIVATE PURIFY_PADMM_ALGORITHM=3 PURIFY_GPU)
    add_example(local_epsilon_distributed_grids_real_data_gpu padmm_mpi_real_data.cc NOTEST
      LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
    target_compile_definitions(example_local_epsilon_distributed_grids_real_data_gpu
      PRIVATE PURIFY_PADMM_ALGORITHM=1 PURIFY_GPU)
  endif()
endif()


if(data AND TARGET casacore::ms)
  add_example(casa LIBRARIES libpurify)
endif()

=== cpp/purify/CMakeLists.txt ===
# Add to install includes only if outside build dir
function(add_include_dir)
  unset(publics)
  unset(privates)
  foreach(dir ${ARGN})
    file(RELATIVE_PATH rel "${PROJECT_BINARY_DIR}" "${dir}" )
    if("${rel}" MATCHES "^\\.\\./")
      list(APPEND publics "${dir}")
    endif()
  endforeach()
  if(publics)
    target_include_directories(libpurify SYSTEM PUBLIC ${publics})
  endif()
endfunction()

configure_file(config.in.h "${PROJECT_BINARY_DIR}/include/purify/config.h")

set(HEADERS
  logging.h kernels.h pfitsio.h types.h
  IndexMapping.h utilities.h operators.h wproj_utilities.h
  cimg.h uvfits.h convolution.h measurement_operator_factory.h wavelet_operator_factory.h distribute.h
  update_factory.h
  convergence_factory.h
  algorithm_factory.h
  read_measurements.h
  yaml-parser.h
  integration.h
  wide_field_utilities.h
  wkernel_integration.h
  wproj_operators.h
  uvw_utilities.h
  fly_operators.h
  "${PROJECT_BINARY_DIR}/include/purify/config.h")

set(SOURCES utilities.cc pfitsio.cc logging.cc
  kernels.cc wproj_utilities.cc operators.cc uvfits.cc yaml-parser.cc
  read_measurements.cc distribute.cc integration.cc wide_field_utilities.cc wkernel_integration.cc
  wproj_operators.cc uvw_utilities.cc setup_utils.cc)

if(PURIFY_CASACORE)
  list(APPEND SOURCES casacore.cc)
  list(APPEND HEADERS casacore.h)
endif()

if(PURIFY_H5)
  list(APPEND HEADERS h5reader.h)
endif()

if(PURIFY_MPI)
  list(APPEND HEADERS mpi_utilities.h distribute.h DistributeSparseVector.h
  random_update_factory.h
  AllToAllSparseVector.h)
  list(APPEND SOURCES mpi_utilities.cc distribute.cc AllToAllSparseVector.cc
  random_update_factory.cc)
endif()

add_library(libpurify SHARED ${SOURCES})
set(version "${Purify_VERSION_MAJOR}.${Purify_VERSION_MINOR}.${Purify_VERSION_PATCH}")
set(soversion "${Purify_VERSION_MAJOR}.${Purify_VERSION_MINOR}")
set_target_properties(libpurify PROPERTIES VERSION ${version} SOVERSION ${soversion})
set_target_properties(libpurify PROPERTIES OUTPUT_NAME purify)

if(PURIFY_OPENMP)
  target_link_libraries(libpurify OpenMP::OpenMP_CXX)
endif()

if(PURIFY_MPI)
  target_link_libraries(libpurify ${MPI_LIBRARIES})
  target_include_directories(libpurify SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
endif()

if(PURIFY_ARRAYFIRE)
  list(APPEND HEADERS operators_gpu.h wproj_operators_gpu.h)
  target_link_libraries(libpurify ${ArrayFire_LIBRARIES})
endif()

if(PURIFY_H5)
  target_link_libraries(libpurify ${HDF5_CXX_LIBRARIES})
  target_include_directories(libpurify SYSTEM PUBLIC ${HDF5_INCLUDE_DIR} ${HighFive_INCLUDE_DIR})
endif()

target_include_directories(libpurify PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/>)

add_include_dir(
  ${EIGEN3_INCLUDE_DIR}
  ${Boost_INCLUDE_DIR}
  ${cfitsio_INCLUDE_DIR}
  ${FFTW3_INCLUDE_DIRS}
  ${YAML_CPP_INCLUDE_DIR}
  ${Cubature_INCLUDE_DIR}
  ${CImg_INCLUDE_DIR}
)

target_link_libraries(libpurify
  ${Cubature_LIBRARIES}
  ${FFTW3_LIBRARIES}
  cfitsio
  ${sopt_LIBRARIES}
  yaml-cpp
  Boost::filesystem
  Boost::system
)

if(PURIFY_CASACORE)
  target_link_libraries(libpurify ${CasaCore_LIBRARIES})
endif()

if(TARGET openmp::openmp)
  target_link_libraries(libpurify openmp::openmp)
endif()

if(PURIFY_CUBATURE_LOOKUP)
  add_dependencies(libpurify Lookup-Cubature)
endif()

if(PURIFY_CASACORE_LOOKUP)
  add_dependencies(libpurify Lookup-CasaCore)
endif()

if(PURIFY_HIGHFIVE_LOOKUP)
  add_dependencies(libpurify Lookup-HighFive)
endif()

install(FILES ${HEADERS} DESTINATION include/purify)
install(TARGETS libpurify
  EXPORT PurifyTargets
  DESTINATION share/cmake/Purify
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

=== cpp/tests/CMakeLists.txt ===

include_directories("${PROJECT_SOURCE_DIR}/cpp" "${PROJECT_BINARY_DIR}/include")
add_library(common_catch_main_object OBJECT "common_catch_main.cc")
if(Catch2_FOUND)
  target_link_libraries(common_catch_main_object Catch2::Catch2)
endif()
if(EIGEN3_INCLUDE_DIR)
  target_include_directories(common_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()
if(sopt_FOUND)
  target_include_directories(common_catch_main_object SYSTEM PUBLIC ${sopt_INCLUDE_DIR})
endif()
target_include_directories(common_catch_main_object PUBLIC
  "${EXTERNAL_ROOT}/include/"
  "${PROJECT_BINARY_DIR}/include/"
)
file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs")


add_catch_test(algo_factory LIBRARIES libpurify)
add_catch_test(convolution LIBRARIES libpurify)
add_catch_test(distribute LIBRARIES libpurify)
add_catch_test(index_mapping LIBRARIES libpurify)
add_catch_test(integration LIBRARIES libpurify)
add_catch_test(measurement_factory LIBRARIES libpurify)
add_catch_test(measurement_operator LIBRARIES libpurify)
add_catch_test(operators LIBRARIES libpurify)
add_catch_test(parser_test LIBRARIES libpurify)
add_catch_test(purify_fitsio LIBRARIES libpurify)
add_catch_test(read_measurements LIBRARIES libpurify)
add_catch_test(sparse LIBRARIES libpurify)
add_catch_test(utils LIBRARIES libpurify)
add_catch_test(uvfits LIBRARIES libpurify)
add_catch_test(wavelet_factory LIBRARIES libpurify)
add_catch_test(wide_field_utilities LIBRARIES libpurify)
add_catch_test(wkernel LIBRARIES libpurify)

if(PURIFY_CASACORE)
  add_catch_test(casacore LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY} DEPENDS lookup_dependencies)
endif()

if(PURIFY_ARRAYFIRE)
  include_directories(${ArrayFire_INCLUDE_DIRS})
  add_catch_test(operators_gpu LIBRARIES libpurify ${ArrayFire_LIBRARIES})
endif()

if(PURIFY_H5)
  add_catch_test(purify_h5 LIBRARIES libpurify DEPENDS lookup_dependencies)
endif()

if(PURIFY_MPI)
  add_library(common_mpi_catch_main_object OBJECT "common_mpi_catch_main.cc")
  if(Catch2_FOUND)
    target_link_libraries(common_mpi_catch_main_object Catch2::Catch2)
  endif()
  if(EIGEN3_INCLUDE_DIR)
    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
  endif()
  if(sopt_FOUND)
    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${sopt_INCLUDE_DIR})
  endif()
  target_include_directories(common_mpi_catch_main_object
    PUBLIC ${PROJECT_BINARY_DIR}/include ${MPI_CXX_INCLUDE_PATH})

  function(add_mpi_test testname)
    add_catch_test(${testname} COMMON_MAIN common_mpi_catch_main_object NOTEST ${ARGN})
    unset(arguments)
    if(CATCH_JUNIT)
      set(arguments -r junit -o ${PROJECT_BINARY_DIR}/Testing/${testname}.xml)
    endif()
    if(NOT MPIEXEC_MAX_NUMPROCS)
      set(MPIEXEC_MAX_NUMPROCS 4)
    endif()
    add_test(NAME ${testname}
      COMMAND
      ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS} ${MPIEXEC_PREFLAGS}
      "./test_${testname}" ${arguments})
    set_tests_properties(${testname} PROPERTIES LABELS "catch;mpi")
  endfunction()

  add_mpi_test(distribute_sparse_vector LIBRARIES libpurify)
  add_mpi_test(kmeans LIBRARIES libpurify)
  add_mpi_test(mpi_algo_factory LIBRARIES libpurify)
  add_mpi_test(mpi_measurement_factory LIBRARIES libpurify)
  add_mpi_test(mpi_measurement_operator LIBRARIES libpurify)
  add_mpi_test(mpi_read_measurements LIBRARIES libpurify)
  add_mpi_test(mpi_utilities LIBRARIES libpurify)
  add_mpi_test(mpi_wavelet_factory LIBRARIES libpurify)
  add_mpi_test(mpi_wide_field_utilities LIBRARIES libpurify)
  add_mpi_test(parallel_mpi_utilities LIBRARIES libpurify)
endif()

install(DIRECTORY ${CMAKE_SOURCE_DIR}/data DESTINATION .)

=== cpp/uncertainty_quantification/CMakeLists.txt ===
add_executable(purify_UQ uq_main.cc)
target_link_libraries(purify_UQ libpurify)
set_target_properties(purify_UQ PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

install(TARGETS purify_UQ
  EXPORT PurifyTargets
  DESTINATION share/cmake/Purify
  RUNTIME DESTINATION bin
  )

=== debian/changelog ===
purify (5.0.1-2) unstable; urgency=medium

  * Disable 32-bit build on Salsa
  * Disable long running test_integration test

 -- Ole Streicher <olebole@debian.org>  Thu, 02 Oct 2025 09:39:48 +0200

purify (5.0.1-1) unstable; urgency=medium

  * d/watch: update to format version 5.0
  * New upstream version 5.0.1 (Closes: #1113430)
  * Rediff patches
  * Push sopt build-dep minversion to 5.0

 -- Ole Streicher <olebole@debian.org>  Tue, 30 Sep 2025 20:42:44 +0200

=== debian/control ===
Source: purify
Section: science
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
Build-Depends: architecture-is-64-bit,
               casacore-dev,
               catch2,
               cmake,
               debhelper-compat (= 13),
               libblas-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libccfits-dev,
               libcubature-dev,
               libeigen3-dev,
               libfftw3-dev,
               libsopt-dev (>= 5.0~),
               libspdlog-dev,
               libtiff5-dev,
               libyaml-cpp-dev
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian-astro-team/purify.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/purify
Homepage: https://astro-informatics.github.io/purify/
Rules-Requires-Root: no

Package: purify
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libpurify-dev
Description: Collection of routines for radio interferometric imaging
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.

Package: libpurify2.0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Routines for radio interferometric imaging (shared lib)
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.
 .
 This package contains the shared library.

Package: libpurify-dev
Architecture: any
Section: libdevel
Depends: libpurify2.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: purify
Description: Routines for radio interferometric imaging (development files)
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CMAKE_FLAGS += -DDEB_HOST_MULTIARCH=`dpkg-architecture -qDEB_HOST_MULTIARCH`

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	cp -r /usr/include/eigen3 .
	dh_auto_configure -- $(CMAKE_FLAGS)

=== debian/watch ===
Version: 5
Template: Github
Owner: astro-informatics
Project: purify
